<div align="center">
  <table>
    <tr>
      <td>
        <a href="https://ondewo.com/en/products/natural-language-understanding/">
            <img width="400px" src="https://raw.githubusercontent.com/ondewo/ondewo-logos/master/ondewo_we_automate_your_phone_calls.png"/>
        </a>
      </td>
    </tr>
    <tr>
       <td align="center">
          <a href="https://www.linkedin.com/company/ondewo "><img width="40px" src="https://cdn-icons-png.flaticon.com/512/3536/3536505.png"></a>
          <a href="https://www.facebook.com/ondewo"><img width="40px" src="https://cdn-icons-png.flaticon.com/512/733/733547.png"></a>
          <a href="https://twitter.com/ondewo"><img width="40px" src="https://cdn-icons-png.flaticon.com/512/733/733579.png"> </a>
          <a href="https://www.instagram.com/ondewo.ai/"><img width="40px" src="https://cdn-icons-png.flaticon.com/512/174/174855.png"></a>
          <a href="https://badge.fury.io/js/%40ondewo%2Fsurvey-client-angular"><img src="https://badge.fury.io/js/%40ondewo%2Fsurvey-client-angular.svg" alt="npm version" height="32"></a>
       </td>
    </tr>
  </table>
  <h1 align="center">
    ONDEWO SURVEY Client Angular
  </h1>
</div>

## Overview

`@ondewo/survey-client-angular` is a compiled version of the [ONDEWO SURVEY API](https://github.com/ondewo/ondewo-survey-api) using the [ONDEWO PROTO COMPILER](https://github.com/ondewo/ondewo-proto-compiler). Here you can find the SURVEY API [documentation](https://ondewo.github.io).

ONDEWO APIs use [Protocol Buffers](https://github.com/google/protobuf) version 3 (proto3) as their Interface Definition Language (IDL) to define the API interface and the structure of the payload messages. The same interface definition is used for gRPC versions of the API in all languages.


## Setup

Using NPM:

```shell
npm i --save @ondewo/survey-client-angular
```

Using GitHub:

```shell
git clone https://github.com/ondewo/ondewo-survey-client-angular.git ## Clone repository
cd ondewo-survey-client-angular                                      ## Change into repo-directoy
make setup_developer_environment_locally                          ## Install dependencies
```

## Package structure

```
npm
├── api
│   ├── google
│   │   └── api
│   │       ├── annotations.pb.d.ts
│   │       └── http.pb.d.ts
│   └── ondewo
│       └── survey
│           ├── fhir.pbconf.d.ts
│           ├── fhir.pb.d.ts
│           ├── fhir.pbsc.d.ts
│           ├── survey.pbconf.d.ts
│           ├── survey.pb.d.ts
│           └── survey.pbsc.d.ts
├── esm2022
│   ├── api
│   │   ├── google
│   │   │   └── api
│   │   │       ├── annotations.pb.mjs
│   │   │       └── http.pb.mjs
│   │   └── ondewo
│   │       └── survey
│   │           ├── fhir.pbconf.mjs
│   │           ├── fhir.pb.mjs
│   │           ├── fhir.pbsc.mjs
│   │           ├── survey.pbconf.mjs
│   │           ├── survey.pb.mjs
│   │           └── survey.pbsc.mjs
│   ├── ondewo-survey-client-angular.mjs
│   └── public-api.mjs
├── fesm2022
│   ├── ondewo-survey-client-angular.mjs
│   └── ondewo-survey-client-angular.mjs.map
├── ondewo-survey-api
│   └── README.md
├── index.d.ts
├── LICENSE
├── package.json
├── public-api.d.ts
└── README.md
```

